"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class IssueEntry(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "data",
        "sample",
        "type",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_3 import opencb as opencb_2_9_3

        return {
            "sample": opencb_2_9_3.SampleEntry,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_3 import opencb as opencb_2_9_3

        return {
            "type": opencb_2_9_3.IssueType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_3 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.avro.SampleEntry": opencb_2_9_3.SampleEntry,
            "org.opencb.biodata.models.variant.avro.IssueType": opencb_2_9_3.IssueType,
            "org.opencb.biodata.models.variant.avro.IssueEntry": opencb_2_9_3.IssueEntry,
        }

    __slots__ = [
        "data",
        "sample",
        "type",
    ]

    def __init__(
        self,
        data,
        sample,
        type,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.IssueEntry model.

        :param data:
        :type data: dict[str, str]
        :param sample:
        :type sample: SampleEntry
        :param type:
        :type type: IssueType
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
